/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Software
 *
 *  Copyright (C) 2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2015 by FUJI SOFT INCORPORATED, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥  
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: ModelCarControl.c 113 2015-05-26 04:04:18Z honda $
 */

/*
 *		RC-CARץ
 */

#include "Os.h"
#include "t_syslog.h"
#include "sysmod/serial.h"
#include "sysmod/banner.h"
#include "ModelCarControl.h"

/*


  
  
  PS3ȥRC椹롥
  
PS3ȥ餫Υޥ  
  PS3ȥ餫׵ϡSBDBTPS3ȥ/USBѥå
  UARTѴե०(http://www.runele.com/) ˤꡤRCB3Ѵ졤
  ꥢץȥ롥
  
ư
  ƤΥפȥ֥0.5ü3Ǥ롥

ܥ
   ܥ
   ƥ󥰤Υ˥塼ȥĴ
   ܥ򲡤ؼ郎ONΥOFF
  ܥ
   ɥ饤֤ˤ롥
  ܥ
   Сˤˤ롥
  L1/R1
   ؼON/OFF롥
  L2/R2
   ⡼Υѹ
  
   ֥졼
  
   ϥ
  
   ᥤإåɥ饤ON/OFF
  
   ֥ᥤإåɥ饤ON/OFF

  
CANå
  
 ܥǥϥޥCANå

      : 50ms
 åID : 16 
 åĹ : 11bit
 å   :
                  offset  bits   bit assign
  إåɥ   :  0  :   1   : 0:OFF 1:ON 
  ե   :  1  :   1   : 0:OFF 1:ON 
  ֥졼 :  2  :   1   : 0:OFF 1:ON 
  Хå   :  3  :   1   : 0:OFF 1:ON 
  ֥         :  5  :   2   : 0:OFF 1:ON 2:TOGGLE
  󥫡     :  8  :   3   : 0:OFF 1:L_ON 2:R_ON 3:LR_ON 4:L_BLINK 5:R_BLINK 6:LR_BLINK

 ϥޥCANå

      : åã
 åID : 3
 åĹ : 40bit
 å   : 
  
                     offset  bits
   ƥ󥰳 :  0  :   8  : 
   ®             :  8  :   8  : 
   ƥ     
    ˥塼ȥ    : 16  :   8  : 
   ®       : 24  :   8  : 
   ֥졼         : 32  :   1  : 1:ON 0:OFF
   إåɥ     : 33  :   1  : 1:ON 0:OFF
   ե     : 34  :   1  : 1:ON 0:OFF
   L󥫡      : 35  :   1  : 1:ON 0:OFF
   R󥫡      : 36  :   1  : 1:ON 0:OFF
   ϥ         : 37  :   1  : 1:ON 0:OFF
 */

/*
 *  ƷϤưݻѿ
 */
boolean IsBodyOnECU      = FALSE;
boolean IsOperatorOnECU  = FALSE;
boolean IsControlerOnECU = FALSE;

/*
 *  ץꥱ⡼ɤꤵƤʤν
 */
void
DoAppModeNone(void)
{
	volatile int i;

	led_init();
	while(1){
		for(i = 0; i < 1000000; i++);
		led_out(LED1|LED2|LED3|LED4);
		for(i = 0; i < 1000000; i++);
		led_out(LED_OFF);
	}
}

/*
 *  ץꥱ⡼ɤμ
 */
boolean
GetAppMode(AppModeType *p_appmode)
{
	uint8 dipsw;
	boolean ret = TRUE;

	switch_dip_init();
	dipsw = switch_dip_sense();

	switch (dipsw) {
	  case DSW1:
		*p_appmode = AppMode_Body;
		break;
	  case DSW2:
		*p_appmode = AppMode_Cont;
		break;
	  case DSW3:
		*p_appmode = AppMode_Ope;
		break;
	  case DSW1|DSW2:
		*p_appmode = AppMode_Body_Cont;
		break;
	  case DSW1|DSW3:
		*p_appmode = AppMode_Body_Ope;
		break;
	  case DSW2|DSW3:
		*p_appmode = AppMode_Cont_Ope;
		break;
	  case DSW1|DSW2|DSW3:
		*p_appmode = AppMode_ALL;
		break;
	  default:
		ret = FALSE;
		break;
	}

	return ret;
}

/*
 *  桼ᥤؿ
 *
 *  ץꥱ⡼ɤȽǤȥͥ뵯ư
 */
sint32
main(void)
{
	AppModeType	crt_app_mode;

	if(!GetAppMode(&crt_app_mode)){
		/*
		 *  ͭʥץꥱ⡼ɤꤵƤʤ
		 */
		DoAppModeNone();
	}

	if (crt_app_mode == AppMode_Body) {
		IsBodyOnECU = TRUE;
	}
	else if (crt_app_mode == AppMode_Cont) {
		IsControlerOnECU = TRUE;
	}
	else if (crt_app_mode == AppMode_Ope) {
		IsOperatorOnECU = TRUE;
	}
	else if (crt_app_mode == AppMode_Body_Cont) {
		IsBodyOnECU = TRUE;
		IsControlerOnECU = TRUE;
	}
	else if (crt_app_mode == AppMode_Body_Ope) {
		IsBodyOnECU = TRUE;
		IsOperatorOnECU = TRUE;
	}
	else if (crt_app_mode == AppMode_Cont_Ope) {
		IsControlerOnECU = TRUE;
		IsOperatorOnECU = TRUE;
	}
	else if (crt_app_mode == AppMode_ALL) {
		IsBodyOnECU = TRUE;
		IsControlerOnECU  = TRUE;
		IsOperatorOnECU  = TRUE;
	}

	/*
	 *  OSư
	 */
	StartOS(crt_app_mode);

	while (1) {
	}
}

/*
 *  ȥåץեå롼
 */
void
StartupHook(void)
{
	/*
	 *  ̤ν
	 */ 
	syslog_initialize();
	syslog_msk_log(LOG_UPTO(LOG_INFO));
	InitSerial();
	print_banner();
	syslog(LOG_INFO, "Model Car Control System Start");

	tCanInit();
	tCanSetMailBoxInfo(BODYCMD_CANMSG_RXMBOX_ID, 0, BODYCMD_CANMSG_ID, 0xff);
	tCanSetMailBoxInfo(CONTCMD_CANMSG_RXMBOX_ID, 0, CONTCMD_CANMSG_ID, 0xff);
	tCanEnable();

	/* LedBlinkerϢν */
	LedBlinkerInit();

	/* ܥǥϤ˴ؤ */
	if(IsBodyOnECU) {
		BodyControlInit();
	}

	/* Ϥ˴ؤ */
	if(IsOperatorOnECU) {
		OperationInit();
	}

	/* Ϥ˴ؤ */
	if(IsControlerOnECU) {
		RcCarInit();
	}
}

/*
 *  åȥեå롼
 */
void
ShutdownHook(StatusType Error)
{
	/* λ */
	syslog(LOG_INFO, "");
	syslog(LOG_INFO, "Model Car Control System ShutDown");
	syslog(LOG_INFO, "ShutDownCode:%s", atk2_strerror(Error));
	syslog(LOG_INFO, "");
	TermSerial();
}

/*
 *  ܥǥϤؤξֻؼѿ
 */
volatile BODYCMD g_bodycmd;

/*
 *  Ȥ뤫
 */
boolean g_bodycmd_canmsg_cyclic = FALSE;

/*
 *  ܥǥϥޥɤCANåȤ
 */
void
SendBodyCmdCanMag(void)
{
	uint8 tx_data[2];
	/* դξ */
	static BODYCMD g_pre_bodycmd;

	/* ֻؼѲ̵ʤ */
	if (!g_bodycmd_canmsg_cyclic){
		if((g_bodycmd.headlamp == g_pre_bodycmd.headlamp)  &&
		   (g_bodycmd.foglamp   == g_pre_bodycmd.foglamp)  &&
		   (g_bodycmd.brakelamp == g_pre_bodycmd.brakelamp)&&
		   (g_bodycmd.backlamp  == g_pre_bodycmd.backlamp) &&
		   (g_bodycmd.buzzer    == g_pre_bodycmd.buzzer)   && 
		   (g_bodycmd.winker    == g_pre_bodycmd.winker)) {
			return;
		}
	}

	/* å */
	tx_data[0] = ((g_bodycmd.headlamp  << 7) &  0x80) | 
				 ((g_bodycmd.foglamp   << 6) &  0x40) |
				 ((g_bodycmd.brakelamp << 5) &  0x20) |
				 ((g_bodycmd.backlamp  << 4) &  0x10) |
				 ((g_bodycmd.buzzer    << 2) &  0x0c);
	tx_data[1] = ((g_bodycmd.winker    << 5) &  0xe0);

	tCanSetTxData(BODYCMD_CANMSG_TXMBOX_ID, BODYCMD_CANMSG_ID, tx_data, 2);

	g_pre_bodycmd = g_bodycmd;
}

/*
 *  ܥǥϥޥɤCANåΥѥå
 */
void
UnpackBodyCmdCanMsg(uint8 *p_rx_data)
{
	g_bodycmd.headlamp  = (p_rx_data[0] & 0x80)? TRUE : FALSE;
	g_bodycmd.foglamp   = (p_rx_data[0] & 0x40)? TRUE : FALSE;
	g_bodycmd.brakelamp = (p_rx_data[0] & 0x20)? TRUE : FALSE;
	g_bodycmd.backlamp  = (p_rx_data[0] & 0x10)? TRUE : FALSE;
	g_bodycmd.buzzer    = (p_rx_data[0] & 0x0c) >> 2;
	g_bodycmd.winker    = (p_rx_data[1] & 0xe0) >> 5;
}

/*
 *  ϤؤΥޥɹѿ(ƱECU)
 */
volatile boolean UpDateContCmd = FALSE;

/*
 *  Ϥؤλؼѹ¤
 */
volatile CONTCMD g_contcmd;

/*
 *  ϤؤλؼCANåȤ
 */
void
SendContCmdCanMag(void)
{
	uint8 tx_data[5];

	/* å */
	tx_data[0] = g_contcmd.angle;
	tx_data[1] = g_contcmd.speed;
	tx_data[2] = g_contcmd.steern;
	tx_data[3] = g_contcmd.gain;
	tx_data[4] = ((g_contcmd.brake    << 7) &  0x80) | 
				 ((g_contcmd.headlamp << 6) &  0x40) |
				 ((g_contcmd.foglamp  << 5) &  0x20) |
				 ((g_contcmd.winker_l << 4) &  0x10) |
				 ((g_contcmd.winker_r << 3) &  0x08) |
				 ((g_contcmd.hazard   << 2) &  0x04);

	tCanSetTxData(CONTCMD_CANMSG_TXMBOX_ID, CONTCMD_CANMSG_ID, tx_data, 5);
}

/*
 *  ϥޥɤCANåΥѥå
 */
void
UnpackContCmdCanMsg(uint8 *p_rx_data)
{
	g_contcmd.angle  = p_rx_data[0];
	g_contcmd.speed  = p_rx_data[1];
	g_contcmd.steern = p_rx_data[2];
	g_contcmd.gain   = p_rx_data[3];

	g_contcmd.brake    = (p_rx_data[4] & 0x80)? TRUE : FALSE;
	g_contcmd.headlamp = (p_rx_data[4] & 0x40)? TRUE : FALSE;
	g_contcmd.foglamp  = (p_rx_data[4] & 0x20)? TRUE : FALSE;
	g_contcmd.winker_l = (p_rx_data[4] & 0x10)? TRUE : FALSE;
	g_contcmd.winker_r = (p_rx_data[4] & 0x08)? TRUE : FALSE;
	g_contcmd.hazard   = (p_rx_data[4] & 0x04)? TRUE : FALSE;
}

/*
 *  顼եå롼
 */
void
ErrorHook(StatusType Error)
{
	TaskType	tskid;
	StatusType	ercd;

	/* ¿ŵư׵ᥨ顼̵ */
	if ((OSErrorGetServiceId() == OSServiceId_ActivateTask) && (Error == E_OS_LIMIT)) {
		return;
	}

	syslog(LOG_NOTICE, "## ErrorHook is called !! (%d)", Error);

	ercd = GetTaskID(&tskid);
	if (ercd == E_OK) {
		syslog(LOG_NOTICE, "GetTaskID: %d", (sintptr) tskid);
	}
	else {
		syslog(LOG_NOTICE, "GetTaskID is unavailable.");
	}
	syslog(LOG_NOTICE, "GetISRID: %d", (sintptr) GetISRID());
	syslog(LOG_NOTICE, "OSErrorGetServiceId(): %d", OSErrorGetServiceId());

	ShutdownOS(E_OK);

	return;
}

/*
 *  ץƥեå롼
 */
ProtectionReturnType
ProtectionHook(StatusType FatalError)
{
	StatusType ercd;

	syslog(LOG_INFO, "");
	syslog(LOG_INFO, "ProtectionHook");

	if (FatalError == E_OS_STACKFAULT) {
		syslog(LOG_INFO, "E_OS_STACKFAULT");
		ercd = PRO_SHUTDOWN;
	}
	else if (FatalError == E_OS_PROTECTION_EXCEPTION) {
		syslog(LOG_INFO, "E_OS_PROTECTION_EXCEPTION");
		ercd = PRO_IGNORE;
	}
	else {
		ercd = PRO_SHUTDOWN;
	}

	return(ercd);
}
